## lablgl 0.97

=== Makefile ===
# Ocaml commands
CAMLC=ocamlc
CAMLOPT=ocamlopt
COMPILER=$(CAMLC) -c
OPTCOMP=$(CAMLOPT) -c
LIBRARIAN=ocamlmklib
OPTLIB=$(CAMLOPT) -a
LINKER=$(CAMLC)
OPTLINK=$(CAMLOPT)

include Makefile.config

OCAMLINC=-I $(LABLTKDIR)

# Files
LIBOBJS =	raw.cmo \
		gl.cmo		glLight.cmo	glList.cmo	glMap.cmo \
		glMat.cmo	glMisc.cmo	glPix.cmo	glClear.cmo \
		glTex.cmo	glDraw.cmo	glFunc.cmo	gluMisc.cmo \
		gluNurbs.cmo	gluQuadric.cmo	gluTess.cmo	gluMat.cmo
MLOBJS = $(LIBOBJS)	togl.cmo
OPTOBJS = $(LIBOBJS:.cmo=.cmx)
COBJS =		ml_gl.o		ml_glu.o	ml_raw.o
TOGLOBJS =	ml_togl.o	$(TOGLDIR)/togl.o

# Default rules
.SUFFIXES: .ml .mli .cmo .cmi .cmx .c .o .var .h .opt

.ml.cmo:
	$(COMPILER) $(OCAMLINC) $<

.ml.cmx:
	$(OPTCOMP) $(OCAMLINC) $<

.mli.cmi:
	$(COMPILER) $(OCAMLINC) $<

.c.o:
	$(COMPILER) -ccopt "$(COPTS) -I$(TOGLDIR) $(INCLUDES)" $<

.var.h:
	./var2def < $< > $@

.cmx.opt: lablgl.cmxa liblablgl.a
	$(OPTLINK) -o $@ $(OCAMLINC) -ccopt -L. \
	    unix.cmxa labltk.cmxa lablgl.cmxa togl.cmxa $<

all: 	var2def	var2switch lablgltop lablgl

opt:	lablgl.cmxa togl.cmxa

var2def: var2def.ml
	$(LINKER) -pp camlp4o var2def.ml -o $@

var2switch: var2switch.ml
	$(LINKER) -pp camlp4o var2switch.ml -o $@

lablgl.cma: $(LIBOBJS) $(COBJS) Makefile.config
	$(LIBRARIAN) -o lablgl $(LIBOBJS) $(COBJS) $(GLLIBS) $(XLIBS)

lablgl.cmxa: lablgl.cma $(OPTOBJS) Makefile.config
	$(LIBRARIAN) -o lablgl $(OPTOBJS) $(GLLIBS) $(XLIBS)
	$(RANLIB) lablgl.a

togl.cma: togl.cmo $(TOGLOBJS) Makefile.config
	$(LIBRARIAN) -o togl togl.cmo $(TOGLOBJS) $(GLLIBS) $(TKLIBS) $(XLIBS)

togl.cmxa: togl.cma togl.cmx Makefile.config
	$(LIBRARIAN) -o togl togl.cmx $(GLLIBS) $(TKLIBS) $(XLIBS)
	$(RANLIB) togl.a

#liblablgl.a: $(COBJS)
#	ar rc liblablgl.a $(COBJS)
#	$(RANLIB) liblablgl.a

$(TOGLDIR)/togl.o:
	cd $(TOGLDIR) && $(MAKE) togl.o CC="$(CAMLC)" CFLAGS='-c -ccopt "$(COPTS) $(INCLUDES) $(TK_FLAGS)"'

lablgltop: lablgl.cma togl.cma
	ocamlmktop -I . $(OCAMLINC) -o lablgltop \
	    -dllpath $(LABLTKDIR) -dllpath $(INSTALLDIR) \
	   labltk.cma lablgl.cma togl.cma

lablgl: lablgl.in Makefile.config
	sed -e 's|@LABLTKDIR@|$(LABLTKDIR)|g'	\
	    -e 's|@INSTALLDIR@|'"$(INSTALLDIR)"'|g'	\
	    < lablgl.in > $@
	chmod 755 $@

gl_tags.c: gl_tags.var
	./var2switch -table GL_ < gl_tags.var > $@

tk_tags.c: tk_tags.var
	./var2switch TK_ < tk_tags.var > $@

togl_tags.c: togl_tags.var
	./var2switch TOGL_ < togl_tags.var > $@

glu_tags.c: glu_tags.var
	./var2switch GLU_ < glu_tags.var > $@

install:
	@$(MAKE) real-install LIBDIR=$(LIBDIR)

real-install:
	if test -d $(INSTALLDIR); then : ; else mkdir -p $(INSTALLDIR); fi
	if test `grep -s -c '^$(INSTALLDIR)$$' $(LIBDIR)/ld.conf || :` = 0; \
	then echo $(INSTALLDIR) >> $(LIBDIR)/ld.conf; fi
	cp $(MLOBJS:.cmo=.cmi) $(INSTALLDIR)
	cp $(MLOBJS:.cmo=.mli) $(INSTALLDIR)
	cp liblablgl.a lablgl.cma libtogl.a togl.cma $(INSTALLDIR)
	cp lablgltop $(INSTALLDIR)
	cp lablgl $(BINDIR)
	@if test -f dlllablgl.so; then $(MAKE) installdll; fi
	@if test -f lablgl.cmxa; then $(MAKE) installopt LIBDIR=$(LIBDIR); fi

installdll:
	cp dlllablgl.so dlltogl.so $(INSTALLDIR)

installopt:
	cp lablgl.cmxa lablgl.a togl.cmxa togl.a $(MLOBJS:.cmo=.cmx) $(INSTALLDIR)

clean:
	rm -f *.cm* *.a *.o *.opt *_tags.c *_tags.h *~ \
		var2def var2switch lablgltop lablgl lablgllink lablglopt
	cd $(TOGLDIR) && $(MAKE) clean

depend:
	ocamldep *.ml *.mli > .depend

#dependencies
ml_gl.o: ml_gl.h gl_tags.h gl_tags.c ml_raw.h
ml_tk.o: ml_gl.h tk_tags.h tk_tags.c
ml_aux.o: ml_gl.h
ml_togl.o : ml_gl.h togl_tags.h togl_tags.c
ml_glu.o : ml_gl.h glu_tags.h glu_tags.c
ml_raw.o: raw_tags.h ml_raw.h
include .depend

=== Togl/Makefile ===
# $Id: Makefile,v 1.3 1998/12/11 08:44:04 garrigue Exp $

# Togl - a Tk OpenGL widget
# Version 1.5
# Copyright (C) 1996-1997  Brian Paul and Ben Bederson
# See the LICENSE file for copyright details.

# $Log: Makefile,v $
# Revision 1.3  1998/12/11 08:44:04  garrigue
# Togl 1.5
#
# Revision 1.2  1998/09/16 10:17:27  garrigue
# patched for use with LablGL
#
# Revision 1.1.1.2  1998/12/11 08:35:21  garrigue
# Togl version 1.5
#
# Revision 1.14  1998/03/12 04:11:13  brianp
# updated LIBS for RedHat Linux 5.0
#
# Revision 1.13  1998/03/12 03:08:43  brianp
# added gears demo
#
# Revision 1.12  1997/12/11 02:21:41  brianp
# updated version to 1.5
#
# Revision 1.11  1997/09/18 03:43:00  brianp
# added zip archive target
#
# Revision 1.10  1997/09/17 02:51:45  brianp
# updated tar file list
#
# Revision 1.9  1997/09/17 02:46:01  brianp
# updated for version 1.4
#
# Revision 1.8  1997/03/07 01:25:42  brianp
# added overlay demo
#
# Revision 1.7  1997/02/16 10:03:19  brianp
# updated for version 1.3
#
# Revision 1.6  1996/12/13 21:23:41  brianp
# added -L/usr/X11/lib to LIBS
#
# Revision 1.5  1996/11/05 02:38:30  brianp
# added -f flag to rm commands
# added Togl.html to tar file
#
# Revision 1.4  1996/10/25 03:45:18  brianp
# changed tar commands
#
# Revision 1.3  1996/10/25 00:46:29  brianp
# added SHLINK and SH_LIB stuff
#
# Revision 1.2  1996/10/25 00:43:12  brianp
# misc cleanups
#
# Revision 1.1  1996/10/23 23:15:09  brianp
# Initial revision
#



# Makefile for Togl demos
# You'll probably have to tinker with these macros:


# The C compiler:
CC = cc

# Compiler options:
COPTS = -c -O

# Shared library linker command:
SHLINK = cc -G

# Name for the shared lib:
#SH_LIB = libtogl.so.1.3
SH_LIB = 

# Where to find tcl.h, tk.h, OpenGL/Mesa headers, etc:
INCLUDES = -I/usr/local/include -I/usr/include/tcl

# Where to find libtcl.a, libtk.a, OpenGL/Mesa libraries:
LIBDIRS = -L/usr/local/lib

# Libraries to link with (-ldl for Linux only?):
LIBS = -ltk -ltcl -lGLU -lGL -L/usr/X11/lib -lX11 -lXmu -lXext -lXt -lm -ldl

TK_FLAGS =

# Jacques Garrigue added this line
# Setup in Makefile.config overrides the above definitions
include ../Makefile.config

#### Shouldn't have to change anything beyond this point ####


CFLAGS = $(COPTS) $(INCLUDES) $(TK_FLAGS)

LFLAGS = $(LIBDIRS)


DEMOS = $(SH_LIB) double texture index overlay gears


default: $(DEMOS)


# double demo
double: double.o togl.o
	$(CC) $(LFLAGS) double.o togl.o $(LIBS) -o $@

double.o: double.c togl.h
	$(CC) $(CFLAGS) double.c


# texture demo
texture: texture.o image.o togl.o
	$(CC) $(LFLAGS) texture.o image.o togl.o $(LIBS) -o $@

texture.o: texture.c togl.h
	$(CC) $(CFLAGS) texture.c

image.o: image.c
	$(CC) $(CFLAGS) image.c


# color index demo
index: index.o togl.o
	$(CC) $(LFLAGS) index.o togl.o $(LIBS) -o $@

index.o: index.c togl.h
	$(CC) $(CFLAGS) index.c


# overlay demo
overlay: overlay.o togl.o
	$(CC) $(LFLAGS) overlay.o togl.o $(LIBS) -o $@

overlay.o: overlay.c togl.h
	$(CC) $(CFLAGS) overlay.c


# gears demo
gears: gears.o togl.o
	$(CC) $(LFLAGS) gears.o togl.o $(LIBS) -o $@

gears.o: gears.c togl.h
	$(CC) $(CFLAGS) gears.c


# the togl widget
togl.o: togl.c togl.h
	$(CC) $(CFLAGS) togl.c


#$(SH_LIB): togl.o
#	$(SHLINK) $(LFLAGS) togl.o $(LIBS) -o $@ 



clean:
	-rm -f *.o *~ core

realclean:
	-rm -f *.o *~ core
	-rm -f $(DEMOS)



TOGL = Togl-1.5

FILES = \
	$(TOGL)/README		\
	$(TOGL)/Togl.html	\
	$(TOGL)/LICENSE		\
	$(TOGL)/Makefile	\
	$(TOGL)/*.[ch]		\
	$(TOGL)/*.tcl		\
	$(TOGL)/tree2.rgba	\
	$(TOGL)/ben.rgb

tar:
	cd .. ; \
	tar -cvf $(TOGL).tar $(FILES) ; \
	gzip $(TOGL).tar ; \
	mv $(TOGL).tar.gz $(TOGL)


zip:
	cd .. ; \
	zip -r $(TOGL).zip $(FILES) ; \
	mv $(TOGL).zip $(TOGL)

## lablgl 1.00

=== src/Makefile ===
# Include shared parts
TOPDIR = ..
include ../Makefile.common

# Composite options
INCLUDES = $(GLINCLUDES) $(XINCLUDES)
LIBS = $(GLLIBS) $(XLIBS)
LIBDIRS =


OCAMLINC=-I +labltk

# Files
LIBOBJS =	raw.cmo \
		gl.cmo		glLight.cmo	glList.cmo	glMap.cmo \
		glMat.cmo	glMisc.cmo	glPix.cmo	glClear.cmo \
		glTex.cmo	glDraw.cmo	glFunc.cmo	gluMisc.cmo \
		gluNurbs.cmo	gluQuadric.cmo	gluTess.cmo	gluMat.cmo \
		glArray.cmo
MLOBJS = $(LIBOBJS)	togl.cmo
OPTOBJS = $(LIBOBJS:.cmo=.cmx)
COBJS =		ml_gl$(XO)	ml_glu$(XO)	ml_raw$(XO) ml_glarray$(XO)
TOGLOBJS =	ml_togl$(XO)	$(TOGLDIR)/togl$(XO)

all:	var2def$(XE) var2switch$(XE) lablgl.cma

opt: lablgl.cmxa

var2def$(XE): var2def.ml
	$(LINKER) -pp camlp4o var2def.ml -o $@

var2switch$(XE): var2switch.ml
	$(LINKER) -pp camlp4o var2switch.ml -o $@

ifeq ($(TOOLCHAIN), msvc)
liblablgl$(XA): $(COBJS)
	$(MKLIB)$@ $(COBJS)
dlllablgl.dll: $(COBJS:$(XO)=.d$(XO))
	$(MKDLL)$@ $(COBJS:$(XO)=.d$(XO)) $(GLLIBS) $(OCAMLDLL)
lablgl.cma: liblablgl$(XA) dlllablgl.dll $(LIBOBJS) $(CONFIG)
	$(LINKER) -a -o $@ $(LIBOBJS) \
	  -cclib -llablgl -dllib -llablgl \
	  -cclib "$(GLLIBS)"
lablgl.cmxa: liblablgl$(XA) $(OPTOBJS) $(CONFIG)
	$(OPTLINK) -a -o $@ $(OPTOBJS) -cclib -llablgl \
	  -cclib "$(GLLIBS)"
else
liblablgl.a: $(COBJS) $(CONFIG)
	$(LIBRARIAN) -o lablgl $(COBJS) $(GLLIBS) $(XLIBS)
lablgl.cma: liblablgl.a $(LIBOBJS) $(CONFIG)
	$(LIBRARIAN) -o lablgl $(LIBOBJS) $(GLLIBS) $(XLIBS)
lablgl.cmxa: liblablgl.a $(OPTOBJS) $(CONFIG)
	$(LIBRARIAN) -o lablgl $(OPTOBJS) $(GLLIBS) $(XLIBS)
endif

gl_tags.c: gl_tags.var
	$(VAR2SWITCH) -table GL_ < gl_tags.var > $@

glu_tags.c: glu_tags.var
	$(VAR2SWITCH) GLU_ < glu_tags.var > $@

install:
	if test -d "$(INSTALLDIR)"; then : ; else mkdir -p "$(INSTALLDIR)"; fi
	cp $(LIBOBJS:.cmo=.cmi) "$(INSTALLDIR)"
	cp $(LIBOBJS:.cmo=.mli) "$(INSTALLDIR)"
	cp liblablgl$(XA) lablgl.cma "$(INSTALLDIR)"
	cd "$(INSTALLDIR)" && $(RANLIB) liblablgl$(XA)
	if test -f dlllablgl$(XS); then cp dlllablgl$(XS) "$(DLLDIR)"; fi
	@if test -f lablgl.cmxa; then $(MAKE) installopt; fi

installopt:
	cp lablgl.cmxa lablgl$(XA) $(LIBOBJS:.cmo=.cmx) "$(INSTALLDIR)"
	cd "$(INSTALLDIR)" && $(RANLIB) lablgl$(XA)

clean:
	rm -f *.cm* *.a *.o *.so *.lib *.obj *.exe *.opt *_tags.c *_tags.h *~ \
		*.dll var2def$(XE) var2switch$(XE) lablgltop$(XE) lablgl$(XB)

depend:
	ocamldep  -pp camlp4o *.ml *.mli > .depend

#dependencies
ml_gl$(XO): ml_gl.h gl_tags.h gl_tags.c ml_raw.h
ml_glu$(XO) : ml_gl.h glu_tags.h glu_tags.c
ml_raw$(XO): raw_tags.h ml_raw.h
include .depend

## lablgl 1.01

=== Makefile ===
# Main Makefile, to compile subdirectories

# default
INSTALLDIR = `ocamlc -where`/lablGL
DLLDIR = `ocamlc -where`/stublibs
CONFIG = Makefile.config
include $(CONFIG)

all: lib togl glut

opt: libopt toglopt glutopt

lib:
	cd src && $(MAKE) all LIBDIR="`ocamlc -where`"

libopt:
	cd src && $(MAKE) opt

togl: lib
	cd Togl/src && $(MAKE) all

toglopt: libopt
	cd Togl/src && $(MAKE) opt

glut: lib
	cd LablGlut/src && $(MAKE)

glutopt: libopt
	cd LablGlut/src && $(MAKE) opt

install:
	@$(MAKE) real-install INSTALLDIR="$(INSTALLDIR)" DLLDIR="$(DLLDIR)"

real-install:
	cd src && $(MAKE) install
	cd Togl/src && $(MAKE) install
	cd LablGlut/src && $(MAKE) install

clean:
	cd src && $(MAKE) clean
	cd Togl/src && $(MAKE) clean
	cd LablGlut/src && $(MAKE) clean

=== src/Makefile ===
--- 
+++ 
@@ -19,7 +19,8 @@
 		glArray.cmo
 MLOBJS = $(LIBOBJS)	togl.cmo
 OPTOBJS = $(LIBOBJS:.cmo=.cmx)
-COBJS =		ml_gl$(XO)	ml_glu$(XO)	ml_raw$(XO) ml_glarray$(XO)
+COBJS =		ml_gl$(XO)	ml_glu$(XO)	ml_raw$(XO) ml_glarray$(XO) \
+		ml_glutess$(XO)
 TOGLOBJS =	ml_togl$(XO)	$(TOGLDIR)/togl$(XO)
 
 all:	var2def$(XE) var2switch$(XE) lablgl.cma
@@ -81,6 +82,6 @@
 
 #dependencies
 ml_gl$(XO): ml_gl.h gl_tags.h gl_tags.c ml_raw.h
-ml_glu$(XO) : ml_gl.h glu_tags.h glu_tags.c
+ml_glu$(XO) ml_glutess$(XO) : ml_gl.h ml_glu.h glu_tags.h glu_tags.c
 ml_raw$(XO): raw_tags.h ml_raw.h
 include .depend

=== LablGlut/src/Makefile ===
# Include shared parts
TOPDIR = ../..
include $(TOPDIR)/Makefile.common

# Composite options
INCLUDES = $(GLINCLUDES) $(XINCLUDES) -I$(SRCDIR)
LIBS = $(GLUTLIBS) $(GLLIBS) $(XLIBS)
LIBDIRS =

OCAMLINC=

# Files
LIBOBJS = glut.cmo
OPTOBJS = $(LIBOBJS:.cmo=.cmx)
COBJS =	  wrap_gl$(XO)	wrap_glut$(XO)

all: 	lib lablgluttop$(XE) lablglut$(XB)

opt:	libopt

lib:	lablglut.cma

libopt: lablglut.cmxa

ifeq ($(TOOLCHAIN), msvc)
liblablglut$(XA): $(COBJS)
	$(MKLIB)$@ $(COBJS)
dlllablglut.dll: $(COBJS:$(XO)=.d$(XO))
	$(MKDLL)$@ $(COBJS:$(XO)=.d$(XO)) $(GLUTLIBS) $(GLLIBS) $(OCAMLDLL)
lablglut.cma: liblablglut$(XA) dlllablglut.dll $(LIBOBJS) ../../Makefile.config
	$(LINKER) -a -o $@ $(LIBOBJS) \
	  -cclib -llablglut -dllib -llablglut \
	  -cclib "$(GLLIBS)" -cclib "$(GLUTLIBS)"
lablglut.cmxa: liblablglut$(XA) $(OPTOBJS) ../../Makefile.config
	$(OPTLINK) -a -o $@ $(OPTOBJS) -cclib -llablglut \
	  -cclib "$(GLLIBS)" -cclib "$(GLUTLIBS)"
else
liblablglut.a: $(COBJS) ../../Makefile.config
	$(LIBRARIAN) -o lablglut $(COBJS) $(GLUTLIBS) $(GLLIBS) $(XLIBS)
lablglut.cma: liblablglut.a $(LIBOBJS) ../../Makefile.config
	$(LIBRARIAN) -o lablglut $(LIBOBJS) $(GLUTLIBS) $(GLLIBS) $(XLIBS)
lablglut.cmxa: liblablglut.a $(OPTOBJS) ../../Makefile.config
	$(LIBRARIAN) -o lablglut $(OPTOBJS) $(GLUTLIBS) $(GLLIBS) $(XLIBS)
endif

lablgluttop$(XE): lablglut.cma 
	ocamlmktop $(CUSTOMTOP) -I . -I $(SRCDIR) $(OCAMLINC) -o $@ \
	  lablglut.cma lablgl.cma

lablglut: $(CONFIG) Makefile liblablglut$(XA)
	$(MAKE) INSTALLDIR="$(INSTALLDIR)" real-$@

real-lablglut:
	@echo generate lablglut
	echo "#!/bin/sh" > lablglut
	echo "# toplevel with lablGL and LablGlut" >> lablglut
	if test -f dlllablglut$(XS); then \
	    echo 'exec ocaml -I "$(INSTALLDIR)" lablgl.cma lablglut.cma $$*' >> lablglut; \
	 else echo 'exec "$(INSTALLDIR)/lablgluttop" -I "$(INSTALLDIR)" $$*' >> lablglut; fi
	chmod 755 lablglut

install:
	@if test -f lablglut.cma; then $(MAKE) real-install; fi

real-install: 
	if test -d "$(INSTALLDIR)"; then : ; else mkdir -p "$(INSTALLDIR)"; fi
	cp $(LIBOBJS:.cmo=.cmi) "$(INSTALLDIR)"
	cp $(LIBOBJS:.cmo=.mli) "$(INSTALLDIR)"
	cp liblablglut$(XA) lablglut.cma "$(INSTALLDIR)"
	cd "$(INSTALLDIR)" && $(RANLIB) liblablglut$(XA)
	@if test -f dlllablglut$(XS); then $(MAKE) installdll; \
	 else $(MAKE) installtop; fi
	cp lablglut$(XB) "$(BINDIR)"
	@if test -f lablglut.cmxa; then $(MAKE) installopt; fi

installdll:
	cp dlllablglut$(XS) "$(DLLDIR)"

installtop:
	cp lablgluttop$(XE) "$(INSTALLDIR)"

installopt:
	cp lablglut.cmxa lablglut$(XA) $(LIBOBJS:.cmo=.cmx) "$(INSTALLDIR)"
	cd "$(INSTALLDIR)" && $(RANLIB) lablglut$(XA)

clean:
	rm -f *.cm* *.o *.obj *.a *.lib *.so *.dll *.exe *.opt \
	     *_tags.c *_tags.h *~ lablgluttop$(EX) lablglut

depend:
	ocamldep  -pp camlp4o *.ml *.mli > .depend

include .depend

=== Togl/src/Makefile ===
# Include shared parts
TOPDIR = ../..
include $(TOPDIR)/Makefile.common

# Composite options
INCLUDES = -I$(SRCDIR) -I$(TOGLDIR) \
	$(TKINCLUDES) -I. $(GLINCLUDES) $(XINCLUDES)
LIBS = $(TKLIBS) $(GLLIBS) $(XLIBS)
LIBDIRS =

OCAMLINC=-I +labltk -I $(SRCDIR)

# Files
TOGLOBJS =	ml_togl$(XO)	$(TOGLDIR)/togl$(XO)

# Extra rules
.cmx.opt: $(TOPDIR)/src/lablgl.cmxa togl.cmxa
	$(OPTLINK) -o $@ $(OCAMLINC) -ccopt -L. \
	    unix.cmxa labltk.cmxa ../../lablgl.cmxa togl.cmxa $<

all: lablgltop$(XE) lablgl$(XB)

opt: togl.cmxa

ifeq ($(TOOLCHAIN), msvc)
libtogl$(XA): $(TOGLOBJS) $(CONFIG)
	$(MKLIB)$@ $(TOGLOBJS)
dlltogl.dll: $(TOGLOBJS:$(XO)=.d$(XO))
	$(MKDLL)$@ $(TOGLOBJS:$(XO)=.d$(XO)) $(GLLIBS) $(TKLIBS) $(OCAMLDLL)
togl.cma: libtogl$(XA) dlltogl.dll togl.cmo $(CONFIG)
	$(LINKER) -a -o $@ togl.cmo -cclib -ltogl -dllib -ltogl \
	  -cclib "$(GLLIBS) $(TKLIBS)"
togl.cmxa: libtogl$(XA) togl.cmx $(CONFIG)
	$(OPTLINK) -a -o $@ togl.cmx -cclib -ltogl \
	  -cclib "$(GLLIBS) $(TKLIBS)"
#CUSTOMTOP = -verbose -custom unix.cma
else
libtogl.a: $(TOGLOBJS) $(CONFIG)
	$(LIBRARIAN) -o togl $(TOGLOBJS) $(GLLIBS) $(TKLIBS) $(XLIBS)
togl.cma: libtogl.a togl.cmo $(CONFIG)
	$(LIBRARIAN) -o togl togl.cmo $(GLLIBS) $(TKLIBS) $(XLIBS)
togl.cmxa: libtogl.a togl.cmx $(CONFIG)
	$(LIBRARIAN) -o togl togl.cmx $(GLLIBS) $(TKLIBS) $(XLIBS)
endif

$(TOGLDIR)/togl.o:
	cd $(TOGLDIR) && $(MAKE) togl.o CC="$(CAMLC)" CFLAGS='-c -ccopt "$(COPTS) $(INCLUDES) $(TK_FLAGS)"'

$(TOGLDIR)/togl.obj:
	cd $(TOGLDIR) && \
        $(CAMLC) -c -ccopt "-DWIN32 $(COPTS) $(INCLUDES) -I." togl.c

$(TOGLDIR)/togl.d.obj:
	cd $(TOGLDIR) && \
        $(CAMLC) -c -ccopt "/MD /Fotogl.d.obj -DWIN32" \
		-ccopt "$(COPTS) $(INCLUDES) -I." \
		togl.c

lablgltop$(XE): ../../src/lablgl.cma togl.cma
	ocamlmktop $(CUSTOMTOP) -I . $(OCAMLINC) -o $@ \
	  labltk.cma lablgl.cma togl.cma

lablgl: $(CONFIG) Makefile libtogl$(XA)
	$(MAKE) INSTALLDIR="$(INSTALLDIR)" real-$@

real-lablgl:
	@echo generate lablgl
	echo "#!/bin/sh" > lablgl
	echo "# toplevel with lablGL and Togl" >> lablgl
	if test -f dlltogl$(XS); then \
	    echo 'exec ocaml -I +labltk -I "$(INSTALLDIR)" lablgl.cma labltk.cma togl.cma $$*' >> lablgl; \
	 else echo 'exec "$(INSTALLDIR)/lablgltop" -I +labltk -I "$(INSTALLDIR)" $$*' >> lablgl; fi
	chmod 755 lablgl
	

togl_tags.c: togl_tags.var
	$(VAR2SWITCH) TOGL_ < togl_tags.var > $@

install:
	@if test -f lablgltop$(XE); then $(MAKE) toglinstall; fi

toglinstall:
	cp togl.cmi togl.mli libtogl$(XA) togl.cma $(INSTTOP) "$(INSTALLDIR)"
	cd "$(INSTALLDIR)" && $(RANLIB) libtogl$(XA)
	@if test -f dlltogl$(XS); then $(MAKE) installdll; \
	 else $(MAKE) installtop; fi
	cp lablgl$(XB) "$(BINDIR)"
	@if test -f togl.cmxa; then $(MAKE) toglinstallopt; fi

installdll:
	cp dlltogl$(XS) "$(DLLDIR)"

installtop:
	cp lablgltop$(XE) "$(INSTALLDIR)"

toglinstallopt:
	cp togl.cmxa togl$(XA) togl.cmx "$(INSTALLDIR)"
	cd "$(INSTALLDIR)" && $(RANLIB) togl$(XA)

clean:
	rm -f *.cm* *.o *.obj *.so *.lib *.a *.dll *.exe *.opt *_tags.c \
	    *_tags.h *~ lablgltop$(EX) lablgl
	rm -f $(TOGLDIR)/togl$(XO)

depend:
	ocamldep  -pp camlp4o *.ml *.mli > .depend

#dependencies
ml_tk$(XO): $(TOPDIR)/src/ml_gl.h tk_tags.h tk_tags.c
ml_togl$(XO) : $(TOPDIR)/src/ml_gl.h togl_tags.h togl_tags.c
include .depend

## lablgl 1.02

=== Makefile ===
--- 
+++ 
@@ -28,6 +28,11 @@
 glutopt: libopt
 	cd LablGlut/src && $(MAKE) opt
 
+preinstall:
+	cd src && $(MAKE) preinstall INSTALLDIR="$(INSTALLDIR)" DLLDIR="$(DLLDIR)"
+	cd Togl/src && $(MAKE) preinstall INSTALLDIR="$(INSTALLDIR)" DLLDIR="$(DLLDIR)"
+	cd LablGlut/src && $(MAKE) preinstall INSTALLDIR="$(INSTALLDIR)" DLLDIR="$(DLLDIR)"
+
 install:
 	@$(MAKE) real-install INSTALLDIR="$(INSTALLDIR)" DLLDIR="$(DLLDIR)"

=== LablGlut/src/Makefile ===
--- 
+++ 
@@ -62,15 +62,17 @@
 install:
 	@if test -f lablglut.cma; then $(MAKE) real-install; fi
 
-real-install: 
+preinstall:
 	if test -d "$(INSTALLDIR)"; then : ; else mkdir -p "$(INSTALLDIR)"; fi
-	cp $(LIBOBJS:.cmo=.cmi) "$(INSTALLDIR)"
-	cp $(LIBOBJS:.cmo=.mli) "$(INSTALLDIR)"
-	cp liblablglut$(XA) lablglut.cma "$(INSTALLDIR)"
+	cp $(LIBOBJS:.cmo=.ml) $(LIBOBJS:.cmo=.mli) "$(INSTALLDIR)"
+	cp liblablglut$(XA) "$(INSTALLDIR)"
 	cd "$(INSTALLDIR)" && $(RANLIB) liblablglut$(XA)
 	@if test -f dlllablglut$(XS); then $(MAKE) installdll; \
 	 else $(MAKE) installtop; fi
 	cp lablglut$(XB) "$(BINDIR)"
+
+real-install: preinstall
+	cp $(LIBOBJS:.cmo=.cmi) lablglut.cma "$(INSTALLDIR)"
 	@if test -f lablglut.cmxa; then $(MAKE) installopt; fi
 
 installdll:
@@ -84,7 +86,7 @@
 	cd "$(INSTALLDIR)" && $(RANLIB) lablglut$(XA)
 
 clean:
-	rm -f *.cm* *.o *.obj *.a *.lib *.so *.dll *.exe *.opt \
+	rm -f *.cm* *.o *.obj *.a lib*.lib *.so *.dll *.exe *.opt \
 	     *_tags.c *_tags.h *~ lablgluttop$(EX) lablglut
 
 depend:

=== Togl/src/Makefile ===
--- 
+++ 
@@ -71,20 +71,22 @@
 	    echo 'exec ocaml -I +labltk -I "$(INSTALLDIR)" lablgl.cma labltk.cma togl.cma $$*' >> lablgl; \
 	 else echo 'exec "$(INSTALLDIR)/lablgltop" -I +labltk -I "$(INSTALLDIR)" $$*' >> lablgl; fi
 	chmod 755 lablgl
-	
 
 togl_tags.c: togl_tags.var
 	$(VAR2SWITCH) TOGL_ < togl_tags.var > $@
 
-install:
-	@if test -f lablgltop$(XE); then $(MAKE) toglinstall; fi
-
-toglinstall:
-	cp togl.cmi togl.mli libtogl$(XA) togl.cma $(INSTTOP) "$(INSTALLDIR)"
+preinstall:
+	cp togl.mli togl.ml libtogl$(XA) "$(INSTALLDIR)"
 	cd "$(INSTALLDIR)" && $(RANLIB) libtogl$(XA)
 	@if test -f dlltogl$(XS); then $(MAKE) installdll; \
 	 else $(MAKE) installtop; fi
 	cp lablgl$(XB) "$(BINDIR)"
+
+install:
+	@if test -f lablgltop$(XE); then $(MAKE) toglinstall; fi
+
+toglinstall: preinstall
+	cp togl.cmi togl.cma $(INSTTOP) "$(INSTALLDIR)"
 	@if test -f togl.cmxa; then $(MAKE) toglinstallopt; fi
 
 installdll:

## lablgl 1.03

=== Togl/src/Makefile ===
--- 
+++ 
@@ -52,7 +52,7 @@
 
 $(TOGLDIR)/togl.d.obj:
 	cd $(TOGLDIR) && \
-        $(CAMLC) -c -ccopt "/MD /Fotogl.d.obj -DWIN32" \
+        $(CAMLC) -c -ccopt "/Fotogl.d.obj -DWIN32" \
 		-ccopt "$(COPTS) $(INCLUDES) -I." \
 		togl.c
 
@@ -102,7 +102,7 @@
 clean:
 	rm -f *.cm* *.o *.obj *.so *.lib *.a *.dll *.exe *.opt *_tags.c \
 	    *_tags.h *~ lablgltop$(EX) lablgl
-	rm -f $(TOGLDIR)/togl$(XO)
+	rm -f $(TOGLDIR)/togl$(XO) $(TOGLDIR)/togl.d$(XO)
 
 depend:
 	ocamldep  -pp camlp4o *.ml *.mli > .depend

## lablgl 1.04

=== LablGlut/examples/caml-images/Makefile ===
include $(OCAML)/camlimages/Makefile.config

all: dc

RESULT=ciglut
SOURCES=main.ml
LIBS=lablgl lablglut
INCDIRS=+camlimages +lablGL +lablglut
OCAMLFLAGS=$(COMPFLAGS_CAMLIMAGES)
#OCAMLLDFLAGS=$(COMPFLAGS_CAMLIMAGES) $(LINKFLAGS_CAMLIMAGES)
OCAMLLDFLAGS=$(COMPFLAGS_CAMLIMAGES) $(LINKFLAGS_CAMLIMAGES)

include ./OCamlMakefile

=== debian/changelog ===
lablgl (1.04-5) unstable; urgency=low

  * Use Tcl/Tk 8.5

 -- Stéphane Glondu <glondu@debian.org>  Thu, 17 Dec 2009 12:27:37 +0100

lablgl (1.04-4) unstable; urgency=low

  * Converted to source format 3.0 (quilt)
    - added debian/source/format
  * Fixed the Makefile in the examples to make compilation work.  Patch:
    compilation-examples. Closes: Bug#425465. Thanks a lot to Russell
    Sears for the patch!

 -- Ralf Treinen <treinen@debian.org>  Thu, 03 Dec 2009 21:50:04 +0100

lablgl (1.04-3) unstable; urgency=low

  * debian/rules: switch to dh and dh-ocaml 0.9
  * debian/control:
    - switch to dh-ocaml 0.9
    - move to section ocaml
    - add Homepage
    - update Standards-Version to 3.8.3
    - Build-depends: update dh-ocaml, ocaml and debhelper
    - Uploaders: update my e-mail address, remove Sven

 -- Stéphane Glondu <glondu@debian.org>  Wed, 23 Sep 2009 20:48:30 +0200

lablgl (1.04-2) unstable; urgency=low

  [ Stephane Glondu ]
  * Switch packaging to git
  * Add myself to Uploaders
  * Remove Julien from uploaders
  * Get closer to CDBS interface
  * Remove dpatch dependency
  * Remove versioned dependencies on OCaml introduced for experimental
  * Remove versioned dependencies available in stable
  * Add debian/clean

  [ Samuel Mimram ]
  * Upload to unstable and build with OCaml 3.11.
  * Use dh-ocaml predefined variables.

 -- Samuel Mimram <smimram@debian.org>  Wed, 25 Feb 2009 10:27:41 +0100

lablgl (1.04-1) experimental; urgency=low

  * New upstream release.
  * Updated compat to 7.
  * Updated standards version to 3.8.0.
  * Depend on libgl1-mesa-dev instead of xlibmesa-gl-dev.
  * Depend on libglu1-mesa-dev instead of libglu1-xorg-dev.
  * Depend on x11proto-core-dev instead of x-dev.

 -- Samuel Mimram <smimram@debian.org>  Tue, 10 Feb 2009 12:50:41 +0100

lablgl (1.03-4) experimental; urgency=low

  * Fixed versioning of camlp4 to force resolution against ocaml 3.11
    on experimental.

 -- Romain Beauxis <toots@rastageeks.org>  Wed, 17 Dec 2008 01:37:31 +0100

lablgl (1.03-3) experimental; urgency=low

  * Upload to experimental to build against ocaml 3.11.
  * Versioned build-dep on ocaml to avoid confusion.
  * Added build-dep on dh-ocaml (needs the file ocaml-docbase-template.txt).

 -- Romain Beauxis <toots@rastageeks.org>  Mon, 15 Dec 2008 17:12:48 +0100

lablgl (1.03-2) experimental; urgency=low

  [ Stefano Zacchiroli ]
  * fix vcs-svn field to point just above the debian/ dir

  [ Ralf Treinen ]
  * Recompiled for ocaml 3.10.2.
  * Added myself to Uploaders

 -- Ralf Treinen <treinen@debian.org>  Mon, 07 Apr 2008 20:50:45 +0200

lablgl (1.03-1) unstable; urgency=low

  * New upstream release.
  * We don't need to remove rpaths anymore.
  * Bumped standards version to 3.7.3, no changes needed.

 -- Samuel Mimram <smimram@debian.org>  Tue, 11 Dec 2007 10:03:51 +0000

lablgl (1.02-7) unstable; urgency=low

  * Build-depends on ocaml 3.10.0-8 to be able to generate *.doc-
    base.ocamldoc-apiref

 -- Sylvain Le Gall <gildor@debian.org>  Tue, 04 Sep 2007 17:53:58 +0200

lablgl (1.02-6) unstable; urgency=low

  * Generate ocamldoc documentation

 -- Sylvain Le Gall <gildor@debian.org>  Mon, 03 Sep 2007 23:16:44 +0200

lablgl (1.02-5) unstable; urgency=low

  [ Samuel Mimram ]
  * Correct symlink for lablglut manpage (closes: #435895).
  * Updated watch file.

  [ Sylvain Le Gall ]
  * Upgrade build-dep on ocaml to version 3.10.0

 -- Sylvain Le Gall <gildor@debian.org>  Mon, 03 Sep 2007 16:36:57 +0200

lablgl (1.02-4) experimental; urgency=low

  * Rebuild for ocaml 3.10.0
  * Don't ignore errors in $(MAKE) clean
  * Add myself to uploader
  * Use binary:Version
  * Add manpages for lablgl, lablglut
  * Remove file generated from debian/*.in

 -- Sylvain Le Gall <gildor@debian.org>  Sat, 14 Jul 2007 02:40:56 +0200

lablgl (1.02-3) unstable; urgency=low

  * Build-Depend on debhelper (>= 4.0) since we use compat level 4.
  * Improve copyright file and add missing information there.
  * Move README.Debian to TODO.
  Thanks to Christoph Berg for his remarks about all this.

 -- Julien Cristau <julien.cristau@ens-lyon.org>  Thu, 22 Jun 2006 20:52:30 +0200

lablgl (1.02-2) unstable; urgency=low

  * Rebuild with OCaml 3.09.2.
  * Updated standards version to 3.7.2, no changes needed.

 -- Samuel Mimram <smimram@debian.org>  Mon, 15 May 2006 21:23:56 +0000

lablgl (1.02-1) unstable; urgency=low

  * New upstream release.
  * Rebuild with OCaml 3.09.1.

 -- Samuel Mimram <smimram@debian.org>  Sat,  7 Jan 2006 13:02:34 +0100

lablgl (1.01-9) unstable; urgency=low

  * Build-dep on chrpath and delete the rpath from the stub libraries.
  * Drop lintian overrides.
  * Add myself to Uploaders.
  * liblablgl-ocaml-dev depends on libxmu-dev (Closes: #336128) and
    freeglut3-dev (Closes: #295969).
  * Use freeglut3-dev instead of libglut3-dev in Build-Depends.

 -- Julien Cristau <julien.cristau@ens-lyon.org>  Wed, 30 Nov 2005 19:46:16 +0100

lablgl (1.01-8) unstable; urgency=low

  * Rebuilt for ocaml 3.09.0.
  * No hardcoded ocaml abi versions anymore.

 -- Sven Luther <luther@debian.org>  Thu, 27 Oct 2005 22:29:48 +0000

lablgl (1.01-7) unstable; urgency=low

  [ Julien Cristau ]
  * libXxf86vm is not used by lablgl, so we:
    + remove libxxf86vm-dev dependency from liblablgl-ocaml-dev.
    + remove -lXxf86vm from Makefile.config.
    (Closes: #325915)

  [ Samuel Mimram ]
  * New maintainer, added myself to uploaders.

 -- Samuel Mimram <smimram@debian.org>  Fri,  9 Sep 2005 13:08:23 +0200

lablgl (1.01-6) unstable; urgency=low

  * Added a watch file
  * Added dependency to libglu1-xorg-dev as an alternative to
    xlibmesa-glu-dev.
    (Closes: #319281)
  * Cleanup Build-depends, with explanations for each of them:
    replace xlibs-dev with individual library packages, add tcl8.4-dev, remove
    libncurses5-dev.
    Also remove libxxf86vm-dev, which is not needed. (Julien Cristau)
  * Upgrade to standards 3.6.2.0 (no change)



=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/ocaml/ocamlvars.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh --with ocaml $@

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	cp debian/Makefile.config .

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE)
ifneq ($(OCAML_OPT_ARCH),)
	$(MAKE) opt
endif

	# Quick replacement for docbook/po4a CDBS class
	# TODO: use cdbs + po4a
	xmllint --nonet --noout --postvalid --xinclude $(CURDIR)/debian/xml-man/en/lablgl.xml
	xsltproc --nonet --xinclude --param man.charmap.use.subset 0 \
	  -o $(CURDIR)/  /usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
	  $(CURDIR)/debian/xml-man/en/lablgl.xml

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	[ ! -f "$(CURDIR)/Makefile" ] || [ ! -f "$(CURDIR)/Makefile.config" ] || $(MAKE) clean

.PHONY: override_dh_auto_install
override_dh_auto_install:
	$(MAKE) install									\
		LIBDIR=$(CURDIR)/debian/liblablgl-ocaml-dev$(OCAML_STDLIB_DIR)		\
		DLLDIR=$(CURDIR)/debian/liblablgl-ocaml$(OCAML_STDLIB_DIR)/stublibs	\
		BINDIR=$(CURDIR)/debian/liblablgl-ocaml-dev/usr/bin
	cp debian/META $(CURDIR)/debian/liblablgl-ocaml-dev$(OCAML_STDLIB_DIR)/lablgl
	ln -sf $(OCAML_STDLIB_DIR)/lablgl $(CURDIR)/debian/liblablgl-ocaml-dev$(OCAML_STDLIB_DIR)/lablGL

=== debian/watch ===
version=3
http://wwwfun.kurims.kyoto-u.ac.jp/soft/lsl/lablgl.html dist/lablgl-([0-9]\..*)\.tar\.gz

## lablgl 1.05

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,9 @@
 # Main Makefile, to compile subdirectories
 
 # default
-INSTALLDIR = `ocamlc -where`/lablGL
-DLLDIR = `ocamlc -where`/stublibs
+LIBDIR = `ocamlc -where`
+INSTALLDIR = $(LIBDIR)/lablGL
+DLLDIR = $(LIBDIR)/stublibs
 CONFIG = Makefile.config
 include $(CONFIG)
 
@@ -11,7 +12,7 @@
 opt: libopt toglopt glutopt
 
 lib:
-	cd src && $(MAKE) all LIBDIR="`ocamlc -where`"
+	cd src && $(MAKE) all LIBDIR="$(LIBDIR)"
 
 libopt:
 	cd src && $(MAKE) opt

=== src/Makefile ===
--- 
+++ 
@@ -16,16 +16,19 @@
 		glMat.cmo	glMisc.cmo	glPix.cmo	glClear.cmo \
 		glTex.cmo	glDraw.cmo	glFunc.cmo	gluMisc.cmo \
 		gluNurbs.cmo	gluQuadric.cmo	gluTess.cmo	gluMat.cmo \
-		glArray.cmo
+		glArray.cmo	glShader.cmo
 MLOBJS = $(LIBOBJS)	togl.cmo
 OPTOBJS = $(LIBOBJS:.cmo=.cmx)
 COBJS =		ml_gl$(XO)	ml_glu$(XO)	ml_raw$(XO) ml_glarray$(XO) \
-		ml_glutess$(XO)
+		ml_glutess$(XO)	ml_shader$(XO)
 TOGLOBJS =	ml_togl$(XO)	$(TOGLDIR)/togl$(XO)
 
-all:	var2def$(XE) var2switch$(XE) lablgl.cma
+all: tools
+	$(MAKE) lablgl.cma
 
 opt: lablgl.cmxa
+
+tools: var2def$(XE) var2switch$(XE)
 
 var2def$(XE): var2def.ml
 	$(LINKER) -pp camlp4o var2def.ml -o $@
@@ -46,12 +49,11 @@
 	$(OPTLINK) -a -o $@ $(OPTOBJS) -cclib -llablgl \
 	  -cclib "$(GLLIBS)"
 else
-liblablgl.a: $(COBJS) $(CONFIG)
-	$(LIBRARIAN) -o lablgl $(COBJS) $(GLLIBS) $(XLIBS)
-lablgl.cma: liblablgl.a $(LIBOBJS) $(CONFIG)
-	$(LIBRARIAN) -o lablgl $(LIBOBJS) $(GLLIBS) $(XLIBS)
-lablgl.cmxa: liblablgl.a $(OPTOBJS) $(CONFIG)
-	$(LIBRARIAN) -o lablgl $(OPTOBJS) $(GLLIBS) $(XLIBS)
+liblablgl$(XA): lablgl.cma
+lablgl.cma: $(COBJS) $(LIBOBJS) $(CONFIG)
+	$(LIBRARIAN) -o lablgl $(COBJS) $(LIBOBJS) $(GLLIBS) $(XLIBS)
+lablgl.cmxa: $(COBJS) $(OPTOBJS) $(CONFIG)
+	$(LIBRARIAN) -o lablgl $(COBJS) $(OPTOBJS) $(GLLIBS) $(XLIBS)
 endif
 
 gl_tags.c: gl_tags.var
@@ -60,13 +62,23 @@
 glu_tags.c: glu_tags.var
 	$(VAR2SWITCH) GLU_ < glu_tags.var > $@
 
-install:
+build.ml: build.ml.in ../Makefile.config
+	sed -e "s|@LABLGL_MLS@|$(LIBOBJS:.cmo=)|" \
+	    -e "s|@TOGL_MLS@|togl|" \
+	    -e "s|@GLUT_MLS@|glut|" \
+	    -e "s|@GLLIBS@|$(GLLIBS0)|" \
+	    -e "s|@TKLIBS@|$(TKLIBS0)|" \
+	    -e "s|@GLUTLIBS@|$(GLUTLIBS0)|" < build.ml.in > $@
+
+preinstall: build.ml
 	if test -d "$(INSTALLDIR)"; then : ; else mkdir -p "$(INSTALLDIR)"; fi
-	cp $(LIBOBJS:.cmo=.cmi) "$(INSTALLDIR)"
-	cp $(LIBOBJS:.cmo=.mli) "$(INSTALLDIR)"
-	cp liblablgl$(XA) lablgl.cma "$(INSTALLDIR)"
+	cp build.ml $(LIBOBJS:.cmo=.ml) $(LIBOBJS:.cmo=.mli) "$(INSTALLDIR)"
+	cp liblablgl$(XA) "$(INSTALLDIR)"
 	cd "$(INSTALLDIR)" && $(RANLIB) liblablgl$(XA)
 	if test -f dlllablgl$(XS); then cp dlllablgl$(XS) "$(DLLDIR)"; fi
+
+install: preinstall
+	cp $(LIBOBJS:.cmo=.cmi) lablgl.cma "$(INSTALLDIR)"
 	@if test -f lablgl.cmxa; then $(MAKE) installopt; fi
 
 installopt:

=== Togl/src/Makefile ===
--- 
+++ 
@@ -7,7 +7,9 @@
 	$(TKINCLUDES) -I. $(GLINCLUDES) $(XINCLUDES)
 LIBS = $(TKLIBS) $(GLLIBS) $(XLIBS)
 LIBDIRS =
-
+ifeq (TOGL_WS,TOGL_X11)
+COPTS += -DUSE_TCL_STUBS -DUSE_TK_STUBS
+endif
 OCAMLINC=-I +labltk -I $(SRCDIR)
 
 # Files
@@ -22,39 +24,15 @@
 
 opt: togl.cmxa
 
-ifeq ($(TOOLCHAIN), msvc)
-libtogl$(XA): $(TOGLOBJS) $(CONFIG)
-	$(MKLIB)$@ $(TOGLOBJS)
-dlltogl.dll: $(TOGLOBJS:$(XO)=.d$(XO))
-	$(MKDLL)$@ $(TOGLOBJS:$(XO)=.d$(XO)) $(GLLIBS) $(TKLIBS) $(OCAMLDLL)
-togl.cma: libtogl$(XA) dlltogl.dll togl.cmo $(CONFIG)
-	$(LINKER) -a -o $@ togl.cmo -cclib -ltogl -dllib -ltogl \
-	  -cclib "$(GLLIBS) $(TKLIBS)"
-togl.cmxa: libtogl$(XA) togl.cmx $(CONFIG)
-	$(OPTLINK) -a -o $@ togl.cmx -cclib -ltogl \
-	  -cclib "$(GLLIBS) $(TKLIBS)"
-#CUSTOMTOP = -verbose -custom unix.cma
-else
-libtogl.a: $(TOGLOBJS) $(CONFIG)
-	$(LIBRARIAN) -o togl $(TOGLOBJS) $(GLLIBS) $(TKLIBS) $(XLIBS)
-togl.cma: libtogl.a togl.cmo $(CONFIG)
-	$(LIBRARIAN) -o togl togl.cmo $(GLLIBS) $(TKLIBS) $(XLIBS)
-togl.cmxa: libtogl.a togl.cmx $(CONFIG)
-	$(LIBRARIAN) -o togl togl.cmx $(GLLIBS) $(TKLIBS) $(XLIBS)
-endif
+libtogl.a: togl.cma
+togl.cma: togl.cmo $(TOGLOBJS) $(CONFIG)
+	$(LIBRARIAN) -o togl togl.cmo $(TOGLOBJS) $(GLLIBS) $(TKLIBS) $(XLIBS)
+togl.cmxa: togl.cmx $(TOGLOBJS) $(CONFIG)
+	$(LIBRARIAN) -o togl togl.cmx $(TOGLOBJS) $(GLLIBS) $(TKLIBS) $(XLIBS)
 
-$(TOGLDIR)/togl.o:
-	cd $(TOGLDIR) && $(MAKE) togl.o CC="$(CAMLC)" CFLAGS='-c -ccopt "$(COPTS) $(INCLUDES) $(TK_FLAGS)"'
-
-$(TOGLDIR)/togl.obj:
+$(TOGLDIR)/togl$(XO): $(TOGLDIR)/togl.c $(TOPDIR)/Makefile.config
 	cd $(TOGLDIR) && \
-        $(CAMLC) -c -ccopt "-DWIN32 $(COPTS) $(INCLUDES) -I." togl.c
-
-$(TOGLDIR)/togl.d.obj:
-	cd $(TOGLDIR) && \
-        $(CAMLC) -c -ccopt "/Fotogl.d.obj -DWIN32" \
-		-ccopt "$(COPTS) $(INCLUDES) -I." \
-		togl.c
+	$(CAMLC) -verbose -c -ccopt "-D$(TOGL_WS) $(COPTS) $(INCLUDES)" togl.c
 
 lablgltop$(XE): ../../src/lablgl.cma togl.cma
 	ocamlmktop $(CUSTOMTOP) -I . $(OCAMLINC) -o $@ \
@@ -102,7 +80,7 @@
 clean:
 	rm -f *.cm* *.o *.obj *.so *.lib *.a *.dll *.exe *.opt *_tags.c \
 	    *_tags.h *~ lablgltop$(EX) lablgl
-	rm -f $(TOGLDIR)/togl$(XO) $(TOGLDIR)/togl.d$(XO)
+	rm -f $(TOGLDIR)/Makefile $(TOGLDIR)/*.o $(TOGLDIR)/*.obj
 
 depend:
 	ocamldep  -pp camlp4o *.ml *.mli > .depend

=== debian/changelog ===
lablgl (1:1.05-3) unstable; urgency=medium

  * Switch to the default Tcl/Tk version from 8.5 since 8.5 is to be removed
    from Debian. Thanks to Sergei Golovan for the patch! (closes: #892990)
  * debian/copyright:
    - change license short name "BSD" to "BSD-3-clause"
    - add short license names GPL-2+, LGPL-2.1
    - https in format specifier
  * Standards-Version 4.1.3
  * debhelper compat level 11

 -- Ralf Treinen <treinen@debian.org>  Fri, 16 Mar 2018 09:44:22 +0100

lablgl (1:1.05-2) unstable; urgency=medium

  * Add liblabltk-ocaml-dev to Build-Depends

 -- Stéphane Glondu <glondu@debian.org>  Sat, 10 Oct 2015 06:54:02 +0200

lablgl (1:1.05-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 17 Dec 2013 15:31:14 +0100

lablgl (20120306-2) unstable; urgency=low

  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Tue, 03 Dec 2013 00:38:29 +0100

lablgl (20120306-1) experimental; urgency=low

  [ Ralf Treinen ]
  * Minor language corrections in package descriptions.
  * Fixed spelling error in lablgl.1 manpage.

  [ Mehdi Dogguy ]
  * Fix version number in META
  * Add myself to uploaders

  [ Sylvain Le Gall ]
  * Remove Sylvain Le Gall from uploaders

  [ Lifeng Sun ]
  * New upstream release.
  * Bump debhelper compat level to 9.
  * debian/copyright: switch to Machine-readable format.
  * debian/control:
    - Bump Standards-Version to 3.9.4.
    - Add myself to Uploaders.
    - Update Homepage.
    - Canonical VCS-* fields.
    - liblablgl-ocaml-dev:
      + depends on ocaml-findlib.
      + minor changes to package description.
  * debian/watch: follow ocamlcore.org.

 -- Lifeng Sun <lifongsun@gmail.com>  Wed, 24 Jul 2013 15:21:15 +0800

=== debian/control ===
Source: lablgl
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Samuel Mimram <smimram@debian.org>,
 Stéphane Glondu <glondu@debian.org>,
 Mehdi Dogguy <mehdi@debian.org>,
 Ralf Treinen <treinen@debian.org>,
 Lifeng Sun <lifongsun@gmail.com>
Build-Depends:
 debhelper (>= 11),
 ocaml (>= 4.00.1),
 tcl-dev,
 tk-dev,
 liblabltk-ocaml-dev,
 libgl1-mesa-dev | libgl-dev,
 libglu1-mesa-dev | libglu-dev,
 freeglut3-dev,
 x11proto-core-dev,
 libxmu-dev,
 libx11-dev,
 dpkg-dev (>= 1.13.19),
 docbook-xml,
 docbook-xsl,
 libxml2-utils,
 xsltproc,
 camlp4,
 dh-ocaml (>= 0.9)
Standards-Version: 4.1.3
Homepage: https://forge.ocamlcore.org/projects/lablgl/
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/lablgl.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/lablgl.git

# Reasons for Build-Depends:
#
# debhelper (>= 4.0): used in debian/rules, debian/compat
# ocaml: the ocaml compiler and stdlib, with labltk
# tcl-dev: #include <tcl.h>
# tk-dev: #include <tk.h>
# libgl-dev: #include <GL/gl.h>
#            #include <GL/glx.h>
# libglu-dev: #include <GL/glu.h>
# freeglut3-dev: #include <GL/glut.h>
#               #include <GLUT/*>
# x11proto-core-dev: #include <X11/Xatom.h>
# libxmu-dev: #include <X11/Xmu/StdCmap.h>
# libx11-dev: #include <X11/Xlib.h>
#             #include <X11/Xutil.h>
# dpkg-dev (>= 1.13.19): binary:Version
# docbook-xml (>= 4.4), docbook-xsl, libxml2-utils, xsltproc: manpages
# camlp4: camlp4

Package: liblablgl-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: Runtime libraries for lablgl
 LablGL is an OpenGL interface for Objective Caml. Since it includes
 support for the Togl widget you can comfortably use it with LablTk.
 A GtkGlarea binding for use with lablgtk is also provided.
 .
 This package contains only the dynamic libraries needed for running dynamic
 bytecode executables.

Package: liblablgl-ocaml-dev
Architecture: any
Depends:
 libgl1-mesa-dev | libgl-dev,
 libglu1-mesa-dev | xlibmesa-glu-dev | libglu-dev,
 tk-dev,
 ocaml-findlib,
 libxmu-dev,
 freeglut3-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: OpenGL interface for Objective Caml
 LablGL gives access to the OpenGL interface from Objective Caml. Since it
 includes support for the Togl widget, you can comfortably use it with
 LablTk. A GtkGlarea binding for use with lablgtk is also provided.

=== debian/watch ===
version=3
https://forge.ocamlcore.org/frs/?group_id=291 .*/lablgl-([0-9\.]{1,7})\.tar\.gz

## lablgl 1.06

=== src/Makefile ===
--- 
+++ 
@@ -22,6 +22,7 @@
 COBJS =		ml_gl$(XO)	ml_glu$(XO)	ml_raw$(XO) ml_glarray$(XO) \
 		ml_glutess$(XO)	ml_shader$(XO)
 TOGLOBJS =	ml_togl$(XO)	$(TOGLDIR)/togl$(XO)
+CAMLP4GEN = var2def.ml var2switch.ml
 
 all: tools
 	$(MAKE) lablgl.cma
@@ -30,11 +31,11 @@
 
 tools: var2def$(XE) var2switch$(XE)
 
-var2def$(XE): var2def.ml
-	$(LINKER) -pp camlp4o var2def.ml -o $@
+var2def$(XE): var2def.cmo
+	$(LINKER) $< -o $@
 
-var2switch$(XE): var2switch.ml
-	$(LINKER) -pp camlp4o var2switch.ml -o $@
+var2switch$(XE): var2switch.cmo
+	$(LINKER) $< -o $@
 
 ifeq ($(TOOLCHAIN), msvc)
 liblablgl$(XA): $(COBJS)
@@ -89,8 +90,13 @@
 	rm -f *.cm* *.a *.o *.so *.lib *.obj *.exe *.opt *_tags.c *_tags.h *~ \
 		*.dll var2def$(XE) var2switch$(XE) lablgltop$(XE) lablgl$(XB)
 
+make-camlp4: $(CAMLP4GEN)
+
+clean-camlp4:
+	rm -f $(CAMLP4GEN)
+
 depend:
-	ocamldep  -pp camlp4o *.ml *.mli > .depend
+	ocamldep  -pp $(CAMLP4O) *.ml *.mli > .depend
 
 #dependencies
 ml_gl$(XO): ml_gl.h gl_tags.h gl_tags.c ml_raw.h

=== LablGlut/src/Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 # Files
 LIBOBJS = glut.cmo
 OPTOBJS = $(LIBOBJS:.cmo=.cmx)
-COBJS =	  wrap_gl$(XO)	wrap_glut$(XO)
+COBJS =	  wrap_glut$(XO)
 
 all: 	lib lablgluttop$(XE) lablglut$(XB)
 
@@ -35,12 +35,11 @@
 	$(OPTLINK) -a -o $@ $(OPTOBJS) -cclib -llablglut \
 	  -cclib "$(GLLIBS)" -cclib "$(GLUTLIBS)"
 else
-liblablglut.a: $(COBJS) ../../Makefile.config
-	$(LIBRARIAN) -o lablglut $(COBJS) $(GLUTLIBS) $(GLLIBS) $(XLIBS)
-lablglut.cma: liblablglut.a $(LIBOBJS) ../../Makefile.config
-	$(LIBRARIAN) -o lablglut $(LIBOBJS) $(GLUTLIBS) $(GLLIBS) $(XLIBS)
-lablglut.cmxa: liblablglut.a $(OPTOBJS) ../../Makefile.config
-	$(LIBRARIAN) -o lablglut $(OPTOBJS) $(GLUTLIBS) $(GLLIBS) $(XLIBS)
+liblablglut$(XA): lablglut.cma
+lablglut.cma: $(COBJS) $(LIBOBJS) ../../Makefile.config
+	$(LIBRARIAN) -o lablglut $(COBJS) $(LIBOBJS) $(GLUTLIBS) $(GLLIBS) $(XLIBS)
+lablglut.cmxa: $(COBJS) $(OPTOBJS) ../../Makefile.config
+	$(LIBRARIAN) -o lablglut $(COBJS) $(OPTOBJS) $(GLUTLIBS) $(GLLIBS) $(XLIBS)
 endif
 
 lablgluttop$(XE): lablglut.cma

=== Togl/src/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 ifeq (TOGL_WS,TOGL_X11)
 COPTS += -DUSE_TCL_STUBS -DUSE_TK_STUBS
 endif
-OCAMLINC=-I +labltk -I $(SRCDIR)
+OCAMLINC=-I $(LABLTKDIR) -I $(SRCDIR)
 
 # Files
 TOGLOBJS =	ml_togl$(XO)	$(TOGLDIR)/togl$(XO)

=== debian/changelog ===
lablgl (1:1.06-2) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Remove Lifeng from Uploaders (Closes: #925012)
  * Add Rules-Requires-Root: no
  * Bump Standards-Version to 4.6.2

  [ Debian Janitor ]
  * Update watch file format version to 4.
  * Bump debhelper from old 12 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Repository-Browse.
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on dh-ocaml, dpkg-dev and ocaml.
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Replace dependency on transitional package
      x11proto-core-dev with replacement x11proto-dev.

 -- Stéphane Glondu <glondu@debian.org>  Sat, 02 Sep 2023 08:44:30 +0200

lablgl (1:1.06-1) unstable; urgency=medium

  * New upstream release
    - remove camlp4 from Build-Depends
  * Update Vcs-*
  * Bump Standards-Version to 4.4.0
  * Remove Samuel from Uploaders
  * Bump debhelper compat level to 12
  * Update Homepage and debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Wed, 07 Aug 2019 11:05:06 +0200

=== debian/control ===
--- 
+++ 
@@ -3,34 +3,31 @@
 Priority: optional
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
- Samuel Mimram <smimram@debian.org>,
  Stéphane Glondu <glondu@debian.org>,
  Mehdi Dogguy <mehdi@debian.org>,
- Ralf Treinen <treinen@debian.org>,
- Lifeng Sun <lifongsun@gmail.com>
+ Ralf Treinen <treinen@debian.org>
 Build-Depends:
- debhelper (>= 11),
- ocaml (>= 4.00.1),
+ debhelper-compat (= 13),
+ ocaml,
  tcl-dev,
  tk-dev,
  liblabltk-ocaml-dev,
- libgl1-mesa-dev | libgl-dev,
+ libgl-dev,
  libglu1-mesa-dev | libglu-dev,
  freeglut3-dev,
- x11proto-core-dev,
+ x11proto-dev,
  libxmu-dev,
  libx11-dev,
- dpkg-dev (>= 1.13.19),
  docbook-xml,
  docbook-xsl,
  libxml2-utils,
  xsltproc,
- camlp4,
- dh-ocaml (>= 0.9)
-Standards-Version: 4.1.3
-Homepage: https://forge.ocamlcore.org/projects/lablgl/
-Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/lablgl.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/lablgl.git
+ dh-ocaml
+Standards-Version: 4.6.2
+Rules-Requires-Root: no
+Homepage: https://github.com/garrigue/lablgl
+Vcs-Git: https://salsa.debian.org/ocaml-team/lablgl.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/lablgl
 
 # Reasons for Build-Depends:
 #
@@ -69,7 +66,7 @@
 Package: liblablgl-ocaml-dev
 Architecture: any
 Depends:
- libgl1-mesa-dev | libgl-dev,
+ libgl-dev,
  libglu1-mesa-dev | xlibmesa-glu-dev | libglu-dev,
  tk-dev,
  ocaml-findlib,

=== debian/watch ===
version=4
https://github.com/garrigue/lablgl/releases .*/archive/v(.*)\.tar\.gz

## lablgl 1.07

=== Makefile ===
--- 
+++ 
@@ -1,11 +1,8 @@
 # Main Makefile, to compile subdirectories
 
 # default
-LIBDIR = `ocamlc -where`
-INSTALLDIR = $(LIBDIR)/lablGL
-DLLDIR = $(LIBDIR)/stublibs
-CONFIG = Makefile.config
-include $(CONFIG)
+TOPDIR = .
+include Makefile.common
 
 all: lib togl glut
 
@@ -18,10 +15,10 @@
 	cd src && $(MAKE) opt
 
 togl: lib
-	cd Togl/src && $(MAKE) all
+	cd Togl/src && $(MAKE) LABLTKDIR="$(LABLTKDIR)" all
 
 toglopt: libopt
-	cd Togl/src && $(MAKE) opt
+	cd Togl/src && $(MAKE) LABLTKDIR="$(LABLTKDIR)" opt
 
 glut: lib
 	cd LablGlut/src && $(MAKE)

=== src/Makefile ===
--- 
+++ 
@@ -31,11 +31,17 @@
 
 tools: var2def$(XE) var2switch$(XE)
 
+var2def.cmo: var2def.ml
+	$(OCAMLFIND) $(COMPILER) -package camlp-streams $<
+
 var2def$(XE): var2def.cmo
-	$(LINKER) $< -o $@
+	$(OCAMLFIND) $(LINKER) -package camlp-streams -linkpkg $< -o $@
+
+var2switch.cmo: var2switch.ml
+	$(OCAMLFIND) $(COMPILER) -package camlp-streams $<
 
 var2switch$(XE): var2switch.cmo
-	$(LINKER) $< -o $@
+	$(OCAMLFIND) $(LINKER) -package camlp-streams -linkpkg $< -o $@
 
 ifeq ($(TOOLCHAIN), msvc)
 liblablgl$(XA): $(COBJS)

=== debian/changelog ===
lablgl (1:1.07-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 16:53:06 +0200

lablgl (1:1.07-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sat, 30 Sep 2023 21:27:30 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: lablgl
 Section: ocaml
 Priority: optional
-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
  Stéphane Glondu <glondu@debian.org>,
  Mehdi Dogguy <mehdi@debian.org>,
@@ -12,6 +13,8 @@
  tcl-dev,
  tk-dev,
  liblabltk-ocaml-dev,
+ libcamlp-streams-ocaml-dev,
+ ocaml-findlib,
  libgl-dev,
  libglu1-mesa-dev | libglu-dev,
  freeglut3-dev,

=== debian/rules ===
--- 
+++ 
@@ -6,8 +6,11 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
+VERSION:=$(shell sed -n "s/^LablGL \(.*\):/\1/p" CHANGES | head -n 1)
+export OCAMLINIT_SED=-e 's%@LABLGL_VERSION@%$(VERSION)%g'
+
 %:
-	dh --with ocaml $@
+	dh $@ --with ocaml
 
 .PHONY: override_dh_auto_configure
 override_dh_auto_configure:
@@ -39,3 +42,5 @@
 		BINDIR=$(CURDIR)/debian/liblablgl-ocaml-dev/usr/bin
 	cp debian/META $(CURDIR)/debian/liblablgl-ocaml-dev$(OCAML_STDLIB_DIR)/lablgl
 	ln -sf $(OCAML_STDLIB_DIR)/lablgl $(CURDIR)/debian/liblablgl-ocaml-dev$(OCAML_STDLIB_DIR)/lablGL
+
+override_dh_dwz:
